package com.jiuqi.util;

import java.util.Enumeration;

public class StringTokenEnumeration implements Enumeration
{
    private String text;
    private String delimeter;
    private int cursor;
    
    public StringTokenEnumeration(final String text, final String delimeter) {
        this.text = text;
        this.delimeter = delimeter;
        this.cursor = 0;
    }
    
    public StringTokenEnumeration(final String text) {
        this(text, ".");
    }
    
    public boolean hasMoreElements() {
        return this.text != null && this.cursor < this.text.length();
    }
    
    public Object nextElement() {
        String result = null;
        final int next = this.text.indexOf(this.delimeter, this.cursor);
        if (next >= this.cursor) {
            result = this.text.substring(this.cursor, next);
            this.cursor = next + 1;
        }
        else {
            if (this.cursor < this.text.length()) {
                result = this.text.substring(this.cursor);
            }
            this.cursor = this.text.length();
        }
        return result;
    }
    
    public static void main(final String[] args) {
        final Enumeration itr = new StringTokenEnumeration("a.bc.e..f", ".");
        int i = 0;
        while (itr.hasMoreElements()) {
            System.out.println(String.valueOf(i) + ":" + itr.nextElement());
            ++i;
        }
    }
}
